this.name					= "cargoSpotter_worldScript.js";
this.author					= "Thargoid";
this.copyright				= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description			= "Script for Cargo Spotter";
this.version				= "1.01";
"use strict";

this.startUp = this.shipLaunchedFromStation = function()
	{ missionVariables.cargoSpotter = "INACTIVE"; }

this.$startTimer = function()
	{ 
	if(!this.scanTimer)
		{ this.scanTimer = new Timer(this, this.$findCargo, 0, 1); } 
	else
		{ this.scanTimer.start(); }
	}
	
this.$findCargo = function()
	{ // cargo pods, alloys, boulders/splinters && uncontrolled thargons
	function $targetCargo(entity) { return (entity.isShip && (entity.isCargo || entity.isBoulder || (entity.hasRole("thargon") && entity.AI === "dumbAI.plist")))  && entity.isInSpace && !entity.hasOwnProperty("$cargoSpotter_tagged") }
	let cargoArray = system.filteredEntities(this, $targetCargo, player.ship, 25600); 
	if(cargoArray.length === 0) { return; }
	
	let cargoCounter = 0 ; // reset the counter
	for(cargoCounter = 0;cargoCounter<cargoArray.length;cargoCounter++)
		{
		cargoArray[cargoCounter].$cargoSpotter_tagged = true;
		this.glowKey = "cargoSpotter_blueGlow"; // default highlight glow for cargopods & alloys
		if(cargoArray[cargoCounter].hasRole("thargon"))
			{ this.glowKey = "cargoSpotter_greenGlow"; } // highlight inactive thargons in green
		if(cargoArray[cargoCounter].isBoulder || cargoArray[cargoCounter].hasRole("splinter"))
			{ this.glowKey = "cargoSpotter_grayGlow"; } // highlight rocks in grey
		if(cargoArray[cargoCounter].hasRole("escape-capsule"))
			{ this.glowKey = "cargoSpotter_redGlow"; } // highlight escape pods in red			
		this.glow = system.addVisualEffect(this.glowKey, cargoArray[cargoCounter].position);
		this.glow.$cargoSpotter_cargoEntity = cargoArray[cargoCounter];
		}
	}
	
this.shipDied = this.shipDockedWithStation = this.$stopTimer = function()
	{
	missionVariables.cargoSpotter = "INACTIVE";
	if(this.scanTimer && this.scanTimer.isRunning) 
		{
		this.scanTimer.stop();  
		delete this.scanTimer;
		}
	}

this.equipmentDamaged = function(equipment)
	{
	if(equipment === "EQ_CARGOSPOTTER") 
		{ 
		missionVariables.cargoSpotter = "INACTIVE";
		this.$stopTimer(); 
		}
	}	